/**********************************************************************
 *
 * mssqldbclass.h -- 
 * Copyright (C) 2008  DL Consulting Ltd
 * Copyright (C) 2010  New Zealand Digital Library Project
 *
 * A component of the Greenstone digital library software
 * from the New Zealand Digital Library Project at the
 * University of Waikato, New Zealand.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *********************************************************************/

#ifndef MSSQLDBCLASS_H
#define MSSQLDBCLASS_H


#include "sqldbclass.h"
//#import "C:\Program Files\Common Files\System\ADO\msado15.dll" no_namespace rename("EOF", "EndOfFile")
#import "C:\Program Files\Common Files\System\ado\msado27.tlb" no_namespace rename("EOF", "EndOfFile")


class mssqldbclass : public sqldbclass
{
 public:

  mssqldbclass ();
  virtual ~mssqldbclass ();
  
  // returns true if opened
  bool opendatabase (const text_t &filename, int mode, int num_retrys, bool need_filelock);
  
  void closedatabase ();
  
  void deletekey (const text_t &key);
  
  text_t getfileextension ();
  
  // returns true on success
  bool getkeydata (const text_t& key, text_t &data);
  
  // returns array of keys
  text_tarray getkeys ();
  
  // returns true on success
  bool setkeydata (const text_t &key, const text_t &data);
  
  // returns array of document OIDs
  virutal text_tarray get_documents_with_metadata_value (const text_tarray &metadata_element_names,
							 const text_t &metadata_value,
							 const text_t &sort_by_metadata_element_name);
  
  // returns array of values
  virtual text_tarray get_metadata_values (const text_tarray &metadata_element_names,
					   const text_t &metadata_value_filter,
					   const text_t &metadata_value_grouping_expression);


 protected:
  _ConnectionPtr dbptr;
  text_t tableid;
  bool debug; // To enable the debug string to be output to cerr.

  virutal text_t sql_safe (const text_t &value_arg);

  virtual bool sqlexec (const text_t &sql);
  virtual bool sqlgetarray (const text_t &sql_cmd, vector<text_tmap> &sql_results);
  virtual bool sqltableexists (const text_t &table_name);

  
  text_tmap read_infodb_file (text_t filename);
  void debug_output (text_t output_string);
  text_t convert_bstr_to_textt (_variant_t in);

};


#endif
